/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: HTTPConfigurationPort.java,v 1.3 1996/08/04 15:22:33 davidw Exp $
//
// $Log: HTTPConfigurationPort.java,v $
// Revision 1.3  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.2  1996/05/06 15:37:25  davidw
// Made into package uk.co.demon.cascade.http
//
// Revision 1.1  1996/04/13 22:08:03  davidw
// Initial revision
//

package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;


import java.util.*;

public class HTTPConfigurationPort implements ConfigurationClass
{
    private static int port;

    static
    {
	port = 80;
    }

    public boolean configure(Vector tokens) throws InvalidHTTPConfigurationException
    {
	if (tokens.size() < 2)
	{
	    throw (new InvalidHTTPConfigurationException("No port number specified")); 
	}

	try
	{
	    String num = (String)tokens.elementAt(1);
	    Integer numVal = Integer.valueOf(num);
	    HTTPSystem.verbose("Setting Port to " + numVal.toString());
	    port = numVal.intValue();
	}
	catch (NumberFormatException e)
	{
	    throw (new InvalidHTTPConfigurationException("Invalid port number specified: " + (String)tokens.elementAt(1))); 
	}

	// Don't need to preserve this class as all data is static
	return false;
    }

    public static int getPort()
    {
	return port;
    }
}



