/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: HTTPConfigurationSetParam.java,v 1.2 1996/08/04 15:22:33 davidw Exp $
//
// $Log: HTTPConfigurationSetParam.java,v $
// Revision 1.2  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.1  1996/06/23 12:37:04  davidw
// Initial revision
//


package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;


import java.util.*;

public class HTTPConfigurationSetParam implements ConfigurationClass
{

    public boolean configure(Vector tokens) throws InvalidHTTPConfigurationException
    {
	if (tokens.size() < 3)
	{
	    throw (new InvalidHTTPConfigurationException("No parameter specified")); 
	}

	try
	{
	    String param = (String)tokens.elementAt(0);
	    StringBuffer val = new StringBuffer();

	    for (int i = 1; i < tokens.size(); i++)
	    {
		val.append((String)tokens.elementAt(i) + " ");
	    }

	    HTTPSystem.verbose("Setting Parameter " + param + " to " + val);
	    HTTPConfiguration.put(param, val.toString().trim());
	}
	catch (NumberFormatException e)
	{
	    throw (new InvalidHTTPConfigurationException("Invalid port number specified: " + (String)tokens.elementAt(1))); 
	}

	// Don't need to preserve this class
	return false;
    }
}




