/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: HTTPHeadMethod.java,v 1.3 1996/08/04 15:22:33 davidw Exp $
//
// $Log: HTTPHeadMethod.java,v $
// Revision 1.3  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.2  1996/06/23 12:43:37  davidw
// Use HTTPInformation instead of HTTPEnvironment
//
// Revision 1.1  1996/06/05 18:11:21  davidw
// Initial revision
//

package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;

import java.io.*;

public class HTTPHeadMethod extends HTTPMethod
{
    private HTTPObject obj = null;
    
    public HTTPHeadMethod()
    {
	super();
    }


    public void process() throws HTTPException
    {
	info.requestMethod = "HEAD";

	PathTranslator tx = new PathTranslator(response, info);
	
	obj = tx.getHTTPObject(path);
	obj.setOutputStream(os);
	
	response.printStatus(os, HTTPStatus.OK);
	
	if (!obj.generatesHeaders())
	{
	    response.printHeaders(os);
	}
	
	obj.start();

    }

    public boolean isAlive()
    {
	if (obj == null)
	{
	    return false;
	}

	return obj.isAlive();
    }
}
