/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: HTTPResponse.java,v 1.6 1996/08/04 15:22:33 davidw Exp $
//
// $Log: HTTPResponse.java,v $
// Revision 1.6  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.5  1996/06/23 12:53:07  davidw
// Pass in HTTPInformation in the constructor in order to set the status
//
// Revision 1.4  1996/05/06 15:37:25  davidw
// Made into package uk.co.demon.cascade.http
//
// Revision 1.3  1996/05/06 10:44:09  davidw
// Improved header generation
//
// Revision 1.2  1996/04/14 17:58:11  davidw
// Add printStatus method
//
// Revision 1.1  1996/04/13 22:03:09  davidw
// Initial revision
//


package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;

import java.util.*;
import java.io.*;

public class HTTPResponse
{
    private Hashtable headers;
    private HTTPInformation info;

    public HTTPResponse(HTTPInformation i)
    {
	headers = new Hashtable();
	info = i;
	
	addHeader("MIME-Version", Info.mimeVersion);
	addHeader("Server", Info.id);
	addHeader("Date", new Date().toGMTString());
    }

    public void addHeader(String type, String value)
    {
	headers.put(type, value);
    }

    public String getHeader(String type)
    {
	return (String) headers.get(type);
    }
    
    public void printStatus(OutputStream os, int status) throws HTTPException
    {
	info.status = status;

	String line = Info.protocolId + " " + status + " " + HTTPStatus.getString(status);
	HTTPSystem.verbose("Response: " + line);
	HTTPSystem.output (os, line + "\r\n");
    }


    public void printHeaders(OutputStream os) throws HTTPException
    {
	Enumeration e;

	for (e = headers.keys(); e.hasMoreElements();)
	{
	    String type = (String) e.nextElement();
	    String value = (String)headers.get(type);

	    String headerLine = type + ": " + value;
	    HTTPSystem.verbose("Response: " + headerLine);
	    HTTPSystem.output (os, headerLine + "\r\n");
	}

	HTTPSystem.output (os, "\r\n");
    }

}

