/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: HTTPServer.java,v 1.3 1996/08/04 15:22:33 davidw Exp $
//
// $Log: HTTPServer.java,v $
// Revision 1.3  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.2  1996/05/06 15:37:25  davidw
// Made into package uk.co.demon.cascade.http
//
// Revision 1.1  1996/04/13 22:03:40  davidw
// Initial revision
//


package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;

import java.io.*;
import java.net.*;

class HTTPServer
{
    private static HTTPConfiguration config;

    public static void main(String s[])
    {
	if (s == null)
	{
	    usage();
	}
	
	init(s[0]);

	runServer();
    }

    public static void usage()
    {
	System.err.println ("Usage: java HTTPServer <config file>");
	System.exit(1);
    }

    private static void runServer()
    {
	try
	{
	    int port = HTTPConfigurationPort.getPort();
	    ServerSocket servSock = new ServerSocket (port);

	    while (true)
	    {
		Socket socket;

		HTTPSystem.verbose ("Listening on port " + port);

		socket = servSock.accept();
		HTTPSystem.verbose ("Socket accept: " + socket.toString());

		HTTPRequest request = new HTTPRequest(socket);
		
		request.start();
	    }
	}
	catch (IOException e)
	{
	    HTTPSystem.fatalError("IOException: getRequest() " + e.getMessage());
	}
    }


    private static void init(String configFile)
    {
	config = new HTTPConfiguration(configFile);
	HTTPSystem.setConfiguration(config);
    }
}


