/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: HTTPStatus.java,v 1.4 1996/08/04 15:22:33 davidw Exp $
//
// $Log: HTTPStatus.java,v $
// Revision 1.4  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.3  1996/05/06 15:37:25  davidw
// Made into package uk.co.demon.cascade.http
//
// Revision 1.2  1996/04/14 17:59:48  davidw
// Full status list from HTTP/1.0 spec and include text strings
//
// Revision 1.1  1996/04/13 22:10:21  davidw
// Initial revision
//


package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;

import java.util.*;


public class HTTPStatus
{
    // Status Codes

    // Informational 1xx
    // Not used

    // Successful 2xx

    public final static int OK                  = 200;
    public final static int CREATED             = 201;
    public final static int ACCEPTED            = 202;
    public final static int NO_CONTENT          = 204;

    // Redirection 3xx

    public final static int MULTIPLE_CHOICES    = 300;
    public final static int MOVED_PERMANENTLY   = 301;
    public final static int MOVED_TEMPORARILY   = 302;
    public final static int NOT_MODIFIED        = 304;
    
    // Client Error 4xx

    public final static int BAD_REQUEST         = 400;
    public final static int UNAUTHORISED        = 401;
    public final static int FORBIDDEN           = 403;
    public final static int NOT_FOUND           = 404;

    // Server Error 5xx
    
    public final static int INTERNAL_ERROR      = 500;
    public final static int NOT_IMPLEMENTED     = 501;
    public final static int BAD_GATEWAY         = 502;
    public final static int SERVICE_UNAVAILABLE = 503;


    // Status Strings

    // Informational 1xx
    // Not used

    // Successful 2xx

    public final static String OK_STRING                  = "OK";
    public final static String CREATED_STRING             = "Created";
    public final static String ACCEPTED_STRING            = "Accepted";
    public final static String NO_CONTENT_STRING          = "No Content";

    // Redirection 3xx

    public final static String MULTIPLE_CHOICES_STRING    = "Multiple Choices";
    public final static String MOVED_PERMANENTLY_STRING   = "Moved Permanently";
    public final static String MOVED_TEMPORARILY_STRING   = "Moved Temporarily";
    public final static String NOT_MODIFIED_STRING        = "Not Modified";
    
    // Client Error 4xx

    public final static String BAD_REQUEST_STRING         = "Bad Request";
    public final static String UNAUTHORISED_STRING        = "Unauthorised";
    public final static String FORBIDDEN_STRING           = "Forbidden";
    public final static String NOT_FOUND_STRING           = "Not Found";

    // Server Error 5xx
    
    public final static String INTERNAL_ERROR_STRING      = "Internal Server Error";
    public final static String NOT_IMPLEMENTED_STRING     = "Not Implemented";
    public final static String BAD_GATEWAY_STRING         = "Bad Gateway";
    public final static String SERVICE_UNAVAILABLE_STRING = "Service Unavailable";


    private static Hashtable strings;

    static
    {
	strings = new Hashtable();

	// Informational 1xx
	// Not used

        // Successful 2xx

	strings.put(new Integer(OK),         OK_STRING);
	strings.put(new Integer(CREATED),    CREATED_STRING);
	strings.put(new Integer(ACCEPTED),   ACCEPTED_STRING);
	strings.put(new Integer(NO_CONTENT), NO_CONTENT_STRING);

        // Redirection 3xx

	strings.put(new Integer(MULTIPLE_CHOICES),  MULTIPLE_CHOICES_STRING);
	strings.put(new Integer(MOVED_PERMANENTLY), MOVED_PERMANENTLY_STRING);
	strings.put(new Integer(MOVED_TEMPORARILY), MOVED_TEMPORARILY_STRING);
	strings.put(new Integer(NOT_MODIFIED),      NOT_MODIFIED_STRING);
    
        // Client Error 4xx

	strings.put(new Integer(BAD_REQUEST),  BAD_REQUEST_STRING);
	strings.put(new Integer(UNAUTHORISED), UNAUTHORISED_STRING);
	strings.put(new Integer(FORBIDDEN),    FORBIDDEN_STRING);
	strings.put(new Integer(NOT_FOUND),    NOT_FOUND_STRING);

        // Server Error 5xx
    
	strings.put(new Integer(INTERNAL_ERROR),      INTERNAL_ERROR_STRING);
	strings.put(new Integer(NOT_IMPLEMENTED),     NOT_IMPLEMENTED_STRING);
	strings.put(new Integer(BAD_GATEWAY),         BAD_GATEWAY_STRING);
	strings.put(new Integer(SERVICE_UNAVAILABLE), SERVICE_UNAVAILABLE_STRING);
    }

    public static String getString(int status)
    {
	return (String) strings.get(new Integer(status));
    }
}
