/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: HTTPSystem.java,v 1.3 1996/08/04 15:22:33 davidw Exp $
//
// $Log: HTTPSystem.java,v $
// Revision 1.3  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.2  1996/05/06 15:37:25  davidw
// Made into package uk.co.demon.cascade.http
//
// Revision 1.1  1996/04/13 22:10:42  davidw
// Initial revision
//

package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;


import java.io.*;

class HTTPSystem
{
    private static HTTPConfiguration config;
    private static int debug;
    private static boolean verbose;

    static 
    {
	debug = 0;
	verbose = false;

	if (System.getProperty("debug") != null)
	{
	    try
	    {
		Integer i = new Integer(System.getProperty("debug"));
		debug = i.intValue();
	    }
	    catch (NumberFormatException e)
	    {
		HTTPSystem.verbose ("Warning: Ignoring invalid debug level " 
				    + System.getProperty("debug"));
	    }
	}

	if (System.getProperty("verbose") != null)
	{
	    verbose = true;
	}
    }


    public static void verbose(String s)
    {
	if (verbose)
	{
	    System.out.println(s);
	}
    }

    public static void debug(String s)
    {
	if (debug > 0)
	{
	    System.out.println(s);
	}
    }

    public static void debug(int level, String s)
    {
	if (debug >= level)
	{
	    System.out.println(s);
	}
    }

    public static void fatalError(String s)
    {
	System.err.println("HTTPServer: " + s);
	System.exit(1);
    }

    public static void setConfiguration(HTTPConfiguration c)
    {
	config = c;
    }
       public static HTTPConfiguration getConfiguration()
    {
	return config;
    }


    public static void output(OutputStream os, String s) throws HTTPException
    {
	int length = s.length();
	char c[] = s.toCharArray();
	byte b[] = new byte[length];

	for (int i = 0; i < length; i++)
	{
	    b[i] = (byte) c[i];
	}

	try
	{
	    os.write(b);
	    os.flush();
	}
	catch (IOException e)
	{
	    HTTPException h = new HTTPException("IOException: " + e.getMessage());
	    throw (h);
	}
    }


}
