/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: LogObject.java,v 1.2 1996/08/04 15:22:33 davidw Exp $
// 
// $Log: LogObject.java,v $
// Revision 1.2  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.1  1996/06/23 12:31:20  davidw
// Initial revision
//

package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;

import java.lang.*;
import java.io.*;
import java.util.*;


public class LogObject
{
    private String filename;
    private String classname;
    private Logger logger;
    private LoggingClass loggingClass;

    public LogObject(String c, String f )
    {
	filename = f;
	classname = c;
    }

    public String getClassname()
    {
	return classname;
    }
    
    public String getFile()
    {
	return filename;
    }

    public Logger getLogger()
    {
	return logger;
    }

    public void init()
    {
	logger = new Logger(filename);
	logger.start();
	loggingClass = loadLoggingClass(classname);
    }


   
    public boolean equals(LogObject other)
    {
	return (classname.equals(other.classname) 
		 && filename.equals(other.filename));
    }



    private LoggingClass loadLoggingClass(String classname)
    {
	HTTPSystem.debug("Loading logging class " + classname);
	
	try
	{
	    Class loggingClass = Class.forName(classname);
	    LoggingClass obj = (LoggingClass)loggingClass.newInstance();
	    return obj;
	}
	catch (ClassNotFoundException e)
	{
	    HTTPSystem.fatalError("Cannot load logging class  "
				  + classname);
	}
	catch (InstantiationException e)
	{
	    HTTPSystem.fatalError("Could not instantiate logging class "
				  + classname + ": " + e.getMessage());
	}
	catch (IllegalAccessException e)
	{
	    HTTPSystem.fatalError("Could not initialise logging class "
				  + classname + ": " + e.getMessage());
	}
	return null;
    }

    public void add(HTTPInformation info)
    {
	logger.add(loggingClass.toString(info));
    }
}

