/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// $Id: LogQueue.java,v 1.2 1996/08/04 15:22:33 davidw Exp $
// 
// $Log: LogQueue.java,v $
// Revision 1.2  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.1  1996/06/23 12:31:20  davidw
// Initial revision
//

// Class to maintain Queue for Logs

package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;

import java.lang.*;
import java.io.*;
import java.util.*;


public class LogQueue
{
    private LogQueueElement root;
    private LogQueueElement last;

    public LogQueue()
    {
	root = new LogQueueElement("Root");
	last = root;
    }
    
    public synchronized void add(String s)
    {
	LogQueueElement e = new LogQueueElement(s);
	last.setNext(e);
	last = e;
	//HTTPSystem.debug(2, "LogQueue.add (" + e.getId() + "):" + s);
    }

    public synchronized String next()
    {
	String s = null;
	LogQueueElement e = root.getNext();

	if (e != null)
	{
	    root.setNext(e.getNext());
	    s = e.toString();
	    //HTTPSystem.debug(2, "LogQueue.getNext (" + e.getId() + "):" + s);
	    if (root.getNext() == null)
	    {
		last = root;
	    }
	}
	return s;
    }

}
