/////////////////////////////////////////////////////////////
// This source code is Copyright (C) David Wilkinson 1996.
// All rights reserved.
//
// For more information,
//
//    Email: davidw@cascade.demon.co.uk
//    URL:   http://www.netlink.co.uk/users/cascade/http/
//
/////////////////////////////////////////////////////////////

// A class used to copy from an input stream to an output stream

// $Id: StreamConnector.java,v 1.5 1996/08/04 15:22:33 davidw Exp $
//
// $Log: StreamConnector.java,v $
// Revision 1.5  1996/08/04 15:22:33  davidw
// Added copyright
//
// Revision 1.4  1996/06/23 13:20:06  davidw
// Count bytes as they go past
//
// Revision 1.3  1996/06/03 20:20:28  davidw
// Flush output stream after writing
// Make sure streams are closed when finished with
//
// Revision 1.2  1996/05/06 15:37:25  davidw
// Made into package uk.co.demon.cascade.http
//
// Revision 1.1  1996/04/28 14:01:44  davidw
// Initial revision
//

package uk.co.demon.cascade.http;
import uk.co.demon.cascade.http.*;

import java.lang.*;
import java.io.*;
import java.util.*;


class StreamConnector extends Thread
{
    private InputStream  is;
    private OutputStream os;
    private static int blockSize = 256;
    private int bytesTransferred = 0;

    private boolean alive;
 
    public StreamConnector(InputStream in, OutputStream out)
    {
	is = in;
	os = out;
	alive = true;
    }


    public void run()
    {
	while (alive)
	{
	    try
	    {
		byte b[] = new byte[blockSize];

		int num = is.read(b);
		HTTPSystem.debug(3, "StreamConnector read " + num + " bytes");
		
		//if (num > 10)
		//{
		//    for (int i=0; i < 10; i++)
		//    {
		//	char c = (char)b[i];
		//	Character ch = new Character(c);
		//	HTTPSystem.debug(3, "["+ i + "]: " + ch.toString());
		//    }
		//}

		if (num == -1)
		{
		    alive = false;
		}
		else
		{
		    os.write(b, 0, num);
		    os.flush();
		}

		bytesTransferred += num;

		// We seem to need to yield here, or else we die...
		yield();
	    }
	    catch (IOException e)
	    {
		HTTPSystem.debug(3, "IOException in StreamConnector: " + e.getMessage());
		alive = false;
	    }
	}

	try 
	{
	    is.close();
	}
	catch (IOException e)
	{
	}
	try 
	{
	    os.close();
	}
	catch (IOException e)
	{
	}
    }

    public void kill()
    {
	alive = false;
    }

    public boolean stillAlive()
    {
	return alive;
    }


    public void resetCount()
    {
	bytesTransferred = 0;
    }

    public int getCount()
    {
	return bytesTransferred;
    }
}

